# https://blog.az.sg/posts/reading-pdfs-in-r/


# ---> EDIT:
workpath_r <- "/Users/m_lauber/Dropbox/knime-workspace/forum/kn_forum_26384_pdf_table_extract_r/data/"
# workpath_r <- "C:\\Users\\XXXXXX\\knime-workspace\\kaggle\\census_income_bigdata_40\\data"

setwd(workpath_r) # Set work directory

library("tabulizer")
library("miniUI")


v_my_pdf <- c("/Users/m_lauber/Dropbox/knime-workspace/forum/kn_forum_26384_pdf_table_extract_r/data/352266__2019_part1__removed.pdf")


# stream seems to work best
df_stream <- extract_tables(
  v_my_pdf ,
  guess = TRUE, 
  method = "stream",
  # output = c("matrix")
  output = c("data.frame")
)

print(df_stream[[1]])
print(df_stream[[2]])
print(df_stream[[3]])
print(df_stream[[4]])

options("encoding" = "UTF-8")

for (i in seq_along(df_stream)) {
  filename = paste0(workpath_r, i, ".csv")
  write.table(df_stream[[i]], file = filename, sep = "|", col.names = TRUE, row.names = FALSE)
  # write.csv(df_stream[[i]], filename)
}


# you could try and locate areas from a browser

locate_areas(v_my_pdf)

df_lattice <- extract_tables(
  v_my_pdf ,
  guess = TRUE, 
  method = "lattice",
  output = c("data.frame")
)

print(df_lattice[[1]])
print(df_lattice[[2]])
print(df_lattice[[3]])
print(df_lattice[[4]])


library(arrow)

for (i in seq_along(df_stream)) {
  var_loc_parquet = paste0(workpath_r, i, ".parquet")
  write_parquet(df_stream[[i]], var_loc_parquet)
  # write.csv(df_stream[[i]], filename)
}


df_decide<- extract_tables(
  v_my_pdf ,
  guess = TRUE, 
  method = "decide",
  # output = c("matrix")
  output = c("data.frame")
)

print(df_decide[[1]])
print(df_decide[[2]])
print(df_decide[[3]])
print(df_decide[[4]])



df_1 <- as.data.frame()


extract_tables(f2, pages = 2, method = "lattice")


# [[1]]
# top      left    bottom     right 
# 325.12871  44.06634 446.84356 549.26634 
# 
# [[2]]
# top      left    bottom     right 
# 325.12871  44.06634 756.96634 554.26832 
# 
# [[3]]
# top      left    bottom     right 
# 156.72871  44.06634 761.96832 557.60297 
# 
# [[4]]
# top      left    bottom     right 
# 328.46337  44.06634 716.95050 552.60099 
# 
# [[5]]
# top      left    bottom     right 
# 158.39604  42.39901 730.28911 550.93366 
# 
# [[6]]
# top      left    bottom     right 
# 325.12871  44.06634 613.57624 550.93366 
# 
# [[7]]
# top      left    bottom     right 
# 328.46337  40.73168 413.49703 550.93366 